/* eslint-disable no-undef */
/* eslint-disable no-plusplus */
/* eslint-disable no-param-reassign */
/* eslint-disable no-console */
const path = require("path");
const crypto = require("crypto");
const appDir = path.resolve(".");

require("dotenv").config({ path: `${appDir}.env` });
const soapRequest = require("easy-soap-request");
const soap = require("soap");
const moment = require("moment");
const md5 = require("md5");

const ns = "http://www.huawei.com.cn/schema/common/v2_1";

const ws = `${__dirname}/wsdl/osg_subscribe_service_1_0.wsdl`;

const vLocation = process.env.VLOCATION;

const uri = process.env.URI;

const smsWs = `${__dirname}/wsdl/SMSParlayX/SMS/parlayx_sms_send_service_2_2.wsdl`;

const smsLoc = process.env.SMSLOC;

const aws = `${__dirname}/wsdl/authorization_service_1_0.wsdl`;

const avLocation = process.env.AVLOCATION;

const cws = `${__dirname}/wsdl/common/parlayx_payment_amount_charging_service_3_1.wsdl`;

const cvLocation = process.env.CvLocation;

const smsNotificationVlocation = process.env.SMS_NOT_VLOCATION;

const startUssdNotificationVlocation = process.env.START_USSD_NOT;

const sendUssdVlocation = process.env.SEND_USSD;

const startSmsNotificationWs = `${__dirname}/wsdl/SMSParlayX/SMS/parlayx_sms_notification_manager_service_2_3.wsdl`;

const serviceEndpoint = process.env.SERVICE_ENDPOINT;

const otpAuthorizationEndpoint = process.env.OTP_AUTHORIZATION_ENDPOINT;

const logFilePrefix = "sdp_";

const logSoapMessages = 1;

const serviceDebug = 1;

const sendSmsNotifyDelivery = 1;

const sendSmsServiceMaxRecipient = 1;

function msisdnSanitizer(msisdn, plus = true) {
  msisdn = msisdn.trim();
  msisdn = msisdn.replace("+", "");
  if (/^234/i.test(msisdn)) {
    msisdn = `0${msisdn.substring(3)}`;
  }

  if (msisdn.length === 11) {
    msisdn = `+234${msisdn.substring(1)}`;
  } else if (msisdn.indexOf("+") === -1) {
    msisdn = `+${msisdn}`;
  }

  if (!plus) {
    msisdn = msisdn.replace("+", "");
  }
  return msisdn;
}

function arrayRand(items) {
  const item = items[Math.floor(Math.random() * items.length)];
  return item.toString();
}

function getTransactionId() {
  let string = "0110000";
  // sum of ip
  const node = 41 + 206 + 4 + 162;
  string += node.toString().padStart(4, "0");
  string += moment(new Date()).format("YYYYMMDDHHmmss");
  const strings = [];
  let i = 1;
  let maxview = 9999;
  for (i; i <= maxview; i++) {
    strings.push(i);
  }
  string += arrayRand(strings).padStart(4, "0");
  i = 1;
  maxview = 999;
  for (i; i <= maxview; i++) {
    strings.push(i);
  }

  string += arrayRand(strings).padStart(3, "0");

  return string;
}

function authorizationLookup(param, spInfo, callback) {
  const msisdn = msisdnSanitizer(param.msisdn, false);

  const timeStamp = moment(new Date()).format("YYYYMMDDHHmmss");
  const spId = spInfo.spid;
  const spPwd = spInfo.service_password;

  const spPassword = md5(spId + spPwd + timeStamp);

  // define wsdl options
  const options = {
    endpoint: avLocation,
    returnFault: true,
    wsdl_options: {
      location: avLocation,
      uri: avLocation,
      trace: 1,
      exceptions: 1,
    },
  };

  const namespace = ns;

  soap.createClient(aws, options, (err, client) => {
    // add header params
    client.addSoapHeader(`
    <tns:RequestSOAPHeader xmlns:tns="${namespace}">
    <tns:spId>${spId}</tns:spId>
    <tns:spPassword>${spPassword}</tns:spPassword>
    <tns:timeStamp>${timeStamp}</tns:timeStamp>
</tns:RequestSOAPHeader>`);

    // payload
    const initParam = {
      endUserIdentifier: msisdn,
      operation: 1,
    };

    // call method
    client.queryAuthorizationList(initParam, (err1, result) => {
      if (err1) {
        return callback(err, false);
      }
      return callback(null, result);
    });
  });
}

async function serviceCharge(param, spInfo, callback) {
  const msisdn = msisdnSanitizer(param.msisdn, false);

  const timeStamp = moment(new Date()).format("YYYYMMDDHHmmss");
  const spPassword = md5(spInfo.spId + spInfo.spPwd + timeStamp);
  const amount = parseInt(param.amount) * 100;
  const refernceCode = getTransactionId();

  const bodyXml = `<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" 
 xmlns:loc="http://www.csapi.org/schema/parlayx/payment/amount_charging/v2_1/local"> 
  <soapenv:Header> 
  <RequestSOAPHeader xmlns="http://www.huawei.com.cn/schema/common/v2_1"> 
  <spId>${spInfo.spId}</spId> 
  <spPassword>${spPassword}</spPassword> 
  <serviceId>${param.service}</serviceId> 
  <timeStamp>${timeStamp}</timeStamp> 
  <OA>${msisdn}</OA> 
 
  <oauth_token>${param.token}</oauth_token>
  </RequestSOAPHeader> 
  </soapenv:Header> 
  <soapenv:Body> 
  <loc:chargeAmount> 
  <loc:endUserIdentifier>${msisdn}</loc:endUserIdentifier> 
  <loc:charge> 
  <description>charge</description> 
  <currency>NGN</currency> 
  <amount>${amount}</amount> 
  <code>4523</code> 
  </loc:charge> 
  <loc:referenceCode>${refernceCode}</loc:referenceCode> 
  </loc:chargeAmount> 
  </soapenv:Body></soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const response = await soapRequest({
    url: cvLocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    return callback(err, false);
    throw new Error(err);
  });

  return callback(null, response);
}

async function genericAuthorization(param, spInfo, callback) {
  const msisdn = msisdnSanitizer(param.msisdn, false);

  const timeStamp = moment(new Date()).format("YYYYMMDDHHmmss");
  const spPassword = md5(spInfo.spId + spInfo.spPwd + timeStamp);
  const transactionId = getTransactionId();

  const bodyXml = `<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:v2="http://www.huawei.com.cn/schema/common/v2_1" xmlns:v1="http://www.csapi.org/schema/authorization/local/v1_0">
    <soapenv:Header>                                                                                                                                                                                
       <v2:RequestSOAPHeader>                                                                                                                                                                       
          <v2:spId>${spInfo.spId}</v2:spId>                                                                                                                                                          
          <v2:spPassword>${spPassword}</v2:spPassword>                                                                                                                           
          <v2:timeStamp>${timeStamp}</v2:timeStamp>                                                                                                                                               
          <v2:serviceId>${param.service}</v2:serviceId>                                                                                                                                              
       </v2:RequestSOAPHeader>                                                                                                                                                                      
    </soapenv:Header>                                                                                                                                                                               
    <soapenv:Body>                                                                                                                                                                                  
       <v1:authorization>                                                                                                                                                                           
          <v1:endUserIdentifier>${param.msisdn}</v1:endUserIdentifier>                                                                                                                                
          <v1:transactionId>${transactionId}</v1:transactionId>    
   <v2:serviceId>${param.service}</v2:serviceId>                                                                                                                                 
          <v1:scope>17</v1:scope>                                                                                                                                                                   
          <v1:amount>${param.amount}</v1:amount>                                                                                                                                                                
          <v1:currency>NGN</v1:currency>                                                                                                                                                            
          <v1:description>Payment Service</v1:description>                                                                                                                                                      
          <v1:contentId/>                                                                                                                                                                           
          <v1:frequency>1</v1:frequency>                                                                                                                                                            
                                                                                                                                              
          <v1:notificationURL>${param.notify_url}</v1:notificationURL>                                                                                                               
          <v1:tokenValidity>1</v1:tokenValidity>                                                                                                                                                    
          <v1:extensionInfo>                                                                                                                                                                        
             <item>                                                                                                                                                                                 
                <key>productName</key>                                                                                                                                                              
                <value>${param.product_name}</value>                                                                                                                                                         
             </item>                                                                                                                                                                                
             <item>                                                                                                                                                                                 
                <key>totalAmount</key>                                                                                                                                                              
                <value>${param.amount}</value>                                                                                                                                                                   
             </item>                                                                                                                                                                                
             <item>                                                                                                                                                                                 
                <key>channel</key>                                                                                                                                                                  
                <value>2</value>                                                                                                                                                                    
             </item>                                                                                                                                                                                
             <item>                                                                                                                                                                                 
                <key>serviceInterval</key>                                                                                                                                                          
                <value>5</value>                                                                                                                                                                    
             </item>                                                                                                                                                                                
             <item>                                                                                                                                                                                 
                <key>serviceIntervalUnit</key>                                                                                                                                                      
                <value>3</value>                                                                                                                                                                    
             </item>                                                                                                                                                                                
             <item>                                                                                                                                                                                 
                <key>tokenType</key>                                                                                                                                                                
                <value>1</value>                                                                                                                                                                    
             </item>     
 
                                                                                                                                                                             
          </v1:extensionInfo>                                                                                                                                                                       
       </v1:authorization>                                                                                                                                                                          
    </soapenv:Body>                                                                                                                                                                                 
 </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const response = await soapRequest({
    url: avLocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    return callback(err, false);
    throw new Error(err);
  });

  return callback(null, response);
}

async function startUssdNotification(param) {
  const correlator = param.correlator
    ? `correlator${param.service_id}`
    : param.correlator;
  const timestamp = moment(new Date()).format("YYYYMMDDHHmmss");

  const spPassword = md5(param.spid + param.service_password + timestamp);

  const bodyXml = `<?xml version="1.0" encoding="UTF-8"?>
 <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:loc="http://www.csapi.org/schema/osg/ussd/notification_manager/v1_0/local">
    <soapenv:Header>
       <tns:RequestSOAPHeader xmlns:tns="http://www.huawei.com.cn/schema/common/v2_1">
          <tns:spId>${param.spid}</tns:spId>
          <tns:spPassword>${spPassword}</tns:spPassword>
          <tns:serviceId>${param.service_id}</tns:serviceId>
          <tns:timeStamp>${timestamp}</tns:timeStamp>
       </tns:RequestSOAPHeader>
    </soapenv:Header>
    <soapenv:Body>
       <loc:startUSSDNotification>
          <loc:reference>
             <endpoint>${param.notify_url}</endpoint>
             <interfaceName>notifyUssdReception</interfaceName>
             <correlator>${correlator}</correlator>
          </loc:reference>
          <loc:ussdServiceActivationNumber>${param.service_number}</loc:ussdServiceActivationNumber>
       </loc:startUSSDNotification>
    </soapenv:Body>
 </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const { response } = await soapRequest({
    url: startUssdNotificationVlocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    throw new Error(err);
  });

  const { headers, body, statusCode } = response;

  console.log(headers);
  console.log(body);
  console.log(statusCode);
}

async function stopUssdNotification(param) {
  const correlator = param.correlator
    ? `correlator${param.service_id}`
    : param.correlator;

  const timestamp = moment(new Date()).format("YYYYMMDDHHmmss");

  const spPassword = md5(param.spid + param.service_password + timestamp);

  const bodyXml = `<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" 
  xmlns:loc="http://www.csapi.org/schema/osg/ussd/notification_manager/v1_0/local"> 
   <soapenv:Header> 
   <tns:RequestSOAPHeader xmlns:tns="http://www.huawei.com.cn/schema/common/v2_1"> 
   <tns:spId>${param.spid}</tns:spId> 
   <tns:spPassword>${spPassword}</tns:spPassword> 
   <tns:serviceId>${param.service_id}</tns:serviceId> 
   <tns:timeStamp>${timestamp}</tns:timeStamp> 
   </tns:RequestSOAPHeader> 
   </soapenv:Header> 
   <soapenv:Body> 
   <loc:stopUSSDNotification> 
   <loc:correlator>${param.correlator}</loc:correlator>
   </loc:stopUSSDNotification> 
   </soapenv:Body> 
  </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const { response } = await soapRequest({
    url: startUssdNotificationVlocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 2000,
  }).catch((err) => {
    throw new Error(err);
  });

  const { headers, body, statusCode } = response;

  console.log(headers);
  console.log(body);
  console.log(statusCode);

  return body;
}

async function sendUssd(param) {
  // const correlator = param.correlator ? `correlator${param.service_id}` : param.correlator;
  const timestamp = moment(new Date()).format("YYYYMMDDHHmmss");

  const spPassword = md5(param.spid + param.service_password + timestamp);

  const bodyXml = `<?xml version="1.0" encoding="UTF-8"?>
 <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:loc="http://www.csapi.org/schema/parlayx/ussd/send/v1_0/local">
    <soapenv:Header>
       <tns:RequestSOAPHeader xmlns:tns="http://www.huawei.com.cn/schema/common/v2_1">
          <tns:spId>${param.spid}</tns:spId>
          <tns:spPassword>${spPassword}</tns:spPassword>
          <tns:serviceId>${param.service_id}</tns:serviceId>
          <tns:timeStamp>${timestamp}</tns:timeStamp>
          <tns:linkid>${param.linkid}</tns:linkid>
       </tns:RequestSOAPHeader>
    </soapenv:Header>
    <soapenv:Body>
       <loc:sendUssd>
          <loc:msgType>${param.msgType}</loc:msgType>
          <loc:senderCB>${param.senderCB}</loc:senderCB>
          <loc:receiveCB>${param.receiveCB}</loc:receiveCB>
          <loc:ussdOpType>${param.option_type}</loc:ussdOpType>
          <loc:msIsdn>${param.msisdn}</loc:msIsdn>
          <loc:serviceCode>${param.shortcode}</loc:serviceCode>
          <loc:codeScheme>68</loc:codeScheme>
          <loc:ussdString>${param.ussd_string}</loc:ussdString>
       </loc:sendUssd>
    </soapenv:Body>
 </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const { response } = await soapRequest({
    url: sendUssdVlocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    throw new Error(err);
  });

  const { headers, body, statusCode } = response;

  console.log(headers);
  console.log(body);
  console.log(statusCode);
}

async function otpAuthorization(param) {
  const timestamp = moment(new Date()).format("YYYYMMDDHHmmss");

  const spPassword = md5(param.spid + param.service_password + timestamp);

  const bodyXml = `<?xml version="1.0" encoding="UTF-8"?>
 <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:v1="http://www.csapi.org/schema/authorization/local/v1_0" xmlns:v2="http://www.huawei.com.cn/schema/common/v2_1">
    <soapenv:Header>
       <v2:RequestSOAPHeader>
          <v2:spId>${param.spid}</v2:spId>
          <v2:spPassword>${spPassword}</v2:spPassword>
          <v2:timeStamp>${timestamp}</v2:timeStamp>
       </v2:RequestSOAPHeader>
    </soapenv:Header>
    <soapenv:Body>
       <v1:authorization>
          <v1:endUserIdentifier>${param.msisdn}</v1:endUserIdentifier>
          <v1:transactionId>${param.transactionId}</v1:transactionId>
          <v1:scope>17</v1:scope>
          <v1:serviceId>${param.service_id}</v1:serviceId>
          <v1:amount>${param.amount}</v1:amount>
          <v1:currency>${param.currency}</v1:currency>
          <v1:description>${param.description}</v1:description>
          <v1:frequency>1</v1:frequency>
       </v1:authorization>
    </soapenv:Body>
 </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const { response } = await soapRequest({
    url: otpAuthorizationEndpoint,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    throw new Error(err);
  });

  const { headers, body, statusCode } = response;

  console.log(headers);
  console.log(body);
  console.log(statusCode);
}

async function startSmsNotification(param, spInfo) {
  const criteria =
    param.criteria.length === 0 ? "default criteria" : param.criteria;
  const correlator = param.correlator
    ? `correlator${param.service}`
    : param.correlator;

  const timestamp = moment(new Date()).format("YYYYMMDDHHmmss");

  const spPassword = md5(spInfo.spId + spInfo.spPwd + timestamp);

  const bodyXml = `<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" 
        xmlns:v2="http://www.huawei.com.cn/schema/common/v2_1" 
        xmlns:loc="http://www.csapi.org/schema/parlayx/sms/notification_manager/v2_3/local"> 
        <soapenv:Header>
                <RequestSOAPHeader xmlns="http://www.huawei.com.cn/schema/common/v2_1"> 
                <spId>${spInfo.spId}</spId>
                <spPassword>${spPassword}<</spPassword>
                <serviceId>${param.service}<</serviceId>
                <timeStamp>${timestamp}<</timeStamp>
                </RequestSOAPHeader>
            </soapenv:Header>
            <soapenv:Body>
                <loc:startSmsNotification>
                    <loc:reference>
                        <endpoint>${param.notify_url}<</endpoint> 
                        <interfaceName>startSmsNotification</interfaceName> 
                        <correlator>${correlator}<</correlator>
                    </loc:reference> 
                    <loc:criteria>${criteria}<</loc:criteria>
                    <loc:smsServiceActivationNumber>${param.shortcode}<</loc:smsServiceActivationNumber> 
                </loc:startSmsNotification>
            </soapenv:Body>
        </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const { response } = await soapRequest({
    url: smsNotificationVlocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    throw new Error(err);
  });

  const { headers, body, statusCode } = response;

  console.log(headers);
  console.log(body);
  console.log(statusCode);
}

async function stopSmsNotification(param, spInfo) {
  const correlator = param.correlator
    ? `correlator${param.service}`
    : param.correlator;

  const timestamp = moment(new Date()).format("YYYYMMDDHHmmss");

  const spPassword = md5(spInfo.spId + spInfo.spPwd + timestamp);

  const bodyXml = `<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" 
    xmlns:v2="http://www.huawei.com.cn/schema/common/v2_1" 
    xmlns:loc="http://www.csapi.org/schema/parlayx/sms/notification_manager/v2_3/local">
    <soapenv:Header>
        <v2:RequestSOAPHeader>
        <spId>${spInfo.spId}</spId>
        <spPassword>${spPassword}<</spPassword>
        <serviceId>${param.service}<</serviceId>
        <timeStamp>${timestamp}<</timeStamp>
        </v2:RequestSOAPHeader>
    </soapenv:Header>
    <soapenv:Body>
        <loc:stopSmsNotification>
        <correlator>${correlator}<</correlator>
        </loc:stopSmsNotification>
    </soapenv:Body>
</soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const { response } = await soapRequest({
    url: smsNotificationVlocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 2000,
  }).catch((err) => {
    throw new Error(err);
  });

  const { headers, body, statusCode } = response;

  console.log(headers);
  console.log(body);
  console.log(statusCode);

  return body;
}

function sendSms(param, spInfo, callback) {
  const msisdn = msisdnSanitizer(param.msisdn, false);

  const userId = `tel:${msisdn}`;

  const timeStamp = moment(new Date()).format("YYYYMMDDHHmmss");
  const spId = spInfo.spid;
  const spPwd = spInfo.service_password;

  const spPassword = md5(spId + spPwd + timeStamp);

  // define wsdl options
  const options = {
    endpoint: smsLoc,
    returnFault: true,
    wsdl_options: {
      location: smsLoc,
      uri: smsLoc,
      trace: 1,
      exceptions: 1,
    },
  };

  const namespace = ns;

  soap.createClient(smsWs, options, (err, client) => {
    // add header params
    client.addSoapHeader(`
    <tns:RequestSOAPHeader xmlns:tns="${namespace}">
    <tns:spId>${spId}</tns:spId>
    <tns:spPassword>${spPassword}</tns:spPassword>
    <tns:timeStamp>${timeStamp}</tns:timeStamp>
    <tns:serviceId>${param.service_id}</tns:serviceId>
    <tns:OA>${userId}</tns:OA>
    <tns:FA>${userId}</tns:FA>
</tns:RequestSOAPHeader>`);

    const initParam = {
      addresses: userId,
      senderName: param.shortcode,
      message: param.message,
      receiptRequest: {
        endpoint: param.notify_url,
        interfaceName: "SmsNotification",
        correlator: param.correlator ? param.correlator : getTransactionId(),
      },
    };

    client.sendSms(initParam, (err1, response) => {
      if (err1) {
        return callback(err1, false);
      }

      return callback(null, response);
    });
  });
}

/**
 * Secure Hash Algorithm (SHA256)
 * http://www.webtoolkit.info/
 * Original code by Angel Marin, Paul Johnston
 **/

function SHA256(s) {
  var chrsz = 8;
  var hexcase = 0;

  function safe_add(x, y) {
    var lsw = (x & 0xffff) + (y & 0xffff);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return (msw << 16) | (lsw & 0xffff);
  }

  function S(X, n) {
    return (X >>> n) | (X << (32 - n));
  }
  function R(X, n) {
    return X >>> n;
  }
  function Ch(x, y, z) {
    return (x & y) ^ (~x & z);
  }
  function Maj(x, y, z) {
    return (x & y) ^ (x & z) ^ (y & z);
  }
  function Sigma0256(x) {
    return S(x, 2) ^ S(x, 13) ^ S(x, 22);
  }
  function Sigma1256(x) {
    return S(x, 6) ^ S(x, 11) ^ S(x, 25);
  }
  function Gamma0256(x) {
    return S(x, 7) ^ S(x, 18) ^ R(x, 3);
  }
  function Gamma1256(x) {
    return S(x, 17) ^ S(x, 19) ^ R(x, 10);
  }

  function core_sha256(m, l) {
    var K = new Array(
      0x428a2f98,
      0x71374491,
      0xb5c0fbcf,
      0xe9b5dba5,
      0x3956c25b,
      0x59f111f1,
      0x923f82a4,
      0xab1c5ed5,
      0xd807aa98,
      0x12835b01,
      0x243185be,
      0x550c7dc3,
      0x72be5d74,
      0x80deb1fe,
      0x9bdc06a7,
      0xc19bf174,
      0xe49b69c1,
      0xefbe4786,
      0xfc19dc6,
      0x240ca1cc,
      0x2de92c6f,
      0x4a7484aa,
      0x5cb0a9dc,
      0x76f988da,
      0x983e5152,
      0xa831c66d,
      0xb00327c8,
      0xbf597fc7,
      0xc6e00bf3,
      0xd5a79147,
      0x6ca6351,
      0x14292967,
      0x27b70a85,
      0x2e1b2138,
      0x4d2c6dfc,
      0x53380d13,
      0x650a7354,
      0x766a0abb,
      0x81c2c92e,
      0x92722c85,
      0xa2bfe8a1,
      0xa81a664b,
      0xc24b8b70,
      0xc76c51a3,
      0xd192e819,
      0xd6990624,
      0xf40e3585,
      0x106aa070,
      0x19a4c116,
      0x1e376c08,
      0x2748774c,
      0x34b0bcb5,
      0x391c0cb3,
      0x4ed8aa4a,
      0x5b9cca4f,
      0x682e6ff3,
      0x748f82ee,
      0x78a5636f,
      0x84c87814,
      0x8cc70208,
      0x90befffa,
      0xa4506ceb,
      0xbef9a3f7,
      0xc67178f2
    );
    var HASH = new Array(
      0x6a09e667,
      0xbb67ae85,
      0x3c6ef372,
      0xa54ff53a,
      0x510e527f,
      0x9b05688c,
      0x1f83d9ab,
      0x5be0cd19
    );
    var W = new Array(64);
    var a, b, c, d, e, f, g, h, i, j;
    var T1, T2;

    m[l >> 5] |= 0x80 << (24 - (l % 32));
    m[(((l + 64) >> 9) << 4) + 15] = l;

    for (var i = 0; i < m.length; i += 16) {
      a = HASH[0];
      b = HASH[1];
      c = HASH[2];
      d = HASH[3];
      e = HASH[4];
      f = HASH[5];
      g = HASH[6];
      h = HASH[7];

      for (var j = 0; j < 64; j++) {
        if (j < 16) W[j] = m[j + i];
        else
          W[j] = safe_add(
            safe_add(
              safe_add(Gamma1256(W[j - 2]), W[j - 7]),
              Gamma0256(W[j - 15])
            ),
            W[j - 16]
          );

        T1 = safe_add(
          safe_add(safe_add(safe_add(h, Sigma1256(e)), Ch(e, f, g)), K[j]),
          W[j]
        );
        T2 = safe_add(Sigma0256(a), Maj(a, b, c));

        h = g;
        g = f;
        f = e;
        e = safe_add(d, T1);
        d = c;
        c = b;
        b = a;
        a = safe_add(T1, T2);
      }

      HASH[0] = safe_add(a, HASH[0]);
      HASH[1] = safe_add(b, HASH[1]);
      HASH[2] = safe_add(c, HASH[2]);
      HASH[3] = safe_add(d, HASH[3]);
      HASH[4] = safe_add(e, HASH[4]);
      HASH[5] = safe_add(f, HASH[5]);
      HASH[6] = safe_add(g, HASH[6]);
      HASH[7] = safe_add(h, HASH[7]);
    }
    return HASH;
  }

  function str2binb(str) {
    var bin = Array();
    var mask = (1 << chrsz) - 1;
    for (var i = 0; i < str.length * chrsz; i += chrsz) {
      bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (24 - (i % 32));
    }
    return bin;
  }

  function Utf8Encode(string) {
    string = string.replace(/\r\n/g, "\n");
    var utftext = "";

    for (var n = 0; n < string.length; n++) {
      var c = string.charCodeAt(n);

      if (c < 128) {
        utftext += String.fromCharCode(c);
      } else if (c > 127 && c < 2048) {
        utftext += String.fromCharCode((c >> 6) | 192);
        utftext += String.fromCharCode((c & 63) | 128);
      } else {
        utftext += String.fromCharCode((c >> 12) | 224);
        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
        utftext += String.fromCharCode((c & 63) | 128);
      }
    }

    return utftext;
  }

  function binb2hex(binarray) {
    var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
    var str = "";
    for (var i = 0; i < binarray.length * 4; i++) {
      str +=
        hex_tab.charAt((binarray[i >> 2] >> ((3 - (i % 4)) * 8 + 4)) & 0xf) +
        hex_tab.charAt((binarray[i >> 2] >> ((3 - (i % 4)) * 8)) & 0xf);
    }
    return str;
  }

  s = Utf8Encode(s);
  return binb2hex(core_sha256(str2binb(s), s.length * chrsz));
}

function generateSHA256Hash(str) {
  const hash = crypto.createHash("SHA256").update(str).digest("base64");
  return hash;
}

function subscribe(msisdn, data, debug = false, callback) {
  msisdn = msisdnSanitizer(msisdn, false);

  if (!/^234/i.test(msisdn)) {
    console.log("not valid msisdn");

    return {
      ResultCode: 3,
      ResultDesc: "Msisdn not allowed",
      ResultDetails: "Subscription Failed",
    };
  }

  const timeStamp = moment(new Date())
    .utc()
    .add(2, "minutes")
    .format("YYYYMMDDHHmmss");
  const spId = data.spid;
  const spPwd = data.service_password;
  const productId = data.productid;

  const spPswCombine = spId + spPwd + timeStamp;
  // const spPassword = SHA256(spId + spPwd + timeStamp);
  const spPassword = generateSHA256Hash(spId + spPwd + timeStamp);

  const userId = msisdn;
  console.log("=========SPPswConbine===========");
  console.log(spPswCombine);
  console.log("=========timestamp===========");
  console.log(timeStamp);
  console.log("=========SPID===========");
  console.log(spId);
  console.log("=========SHA256 encrypted===========\n");
  console.log(spPassword);
  console.log("=========SPpwd===========\n");
  console.log(spPwd);
  console.log("=========Product ID===========");
  console.log(productId);
  console.log("=========Mission ID===========");
  console.log(userId);
  // define wsdl options
  const options = {
    endpoint: vLocation,
    returnFault: true,
    wsdl_options: {
      location: vLocation,
      uri,
      trace: 1,
      exceptions: 1,
    },
  };

  const namespace = ns;

  soap.createClient(ws, options, (err, client) => {
    if (err) {
      return callback(
        {
          ResultCode: 1,
          ResultDesc: err,
          ResultDetails: "Subscription Failed",
        },
        null
      );
    }

    // add header params
    client.addSoapHeader(`
      <tns:RequestSOAPHeader xmlns:tns="${namespace}">
      <tns:spId>${spId}</tns:spId>
      <tns:spPassword>${spPassword}</tns:spPassword>
      <tns:timeStamp>${timeStamp}</tns:timeStamp>
      <tns:OA>${userId}</tns:OA>
      <tns:FA>${userId}</tns:FA>
  </tns:RequestSOAPHeader>`);

    // subscription request payload
    const subscribeProductPayload = {
      subscribeProductReq: {
        userID: {
          ID: userId,
          type: "0",
        },
        subInfo: {
          productID: productId,
          channelID: "4",
          operCode: "ng",
          isAutoExtend: 0,
        },
        extensionInfo: {
          namedParameters: {
            key: "SubType",
            value: 0,
          },
        },
      },
    };

    // call method
    client.subscribeProduct(subscribeProductPayload, (err1, result) => {
      if (err1) {
        return callback(
          {
            ResultCode: 1,
            ResultDesc: err1,
            ResultDetails: "Subscription Failed",
          },
          null
        );
      }

      let des = "Description not available";

      if (result.subscribeProductRsp.resultDescription) {
        des = result.subscribeProductRsp.resultDescription;
      }

      if (debug) {
        const xmlRequest = client.getLastRequest();

        console.log("=========Request===========");
        console.log(xmlRequest);
        console.log("=========Request===========\n");
        const xmlResponse = client.getLastResponse();
        console.log("=========Response===========\n");
        console.log(xmlResponse);
        console.log("=========Response===========");

        return false;
      }

      return callback(null, {
        ResultCode: 0,
        ResultDesc: result.subscribeProductRsp.result,
        ResultDetails: des,
      });
    });
  });
}

async function subscribe12(msisdn, data, debug = false, callback) {
  msisdn = msisdnSanitizer(msisdn, false);

  if (!/^234/i.test(msisdn)) {
    console.log("not valid msisdn");

    return {
      ResultCode: 3,
      ResultDesc: "Msisdn not allowed",
      ResultDetails: "Subscription Failed",
    };
  }

  const timeStamp = moment(new Date())
    .utc()
    .add(2, "minutes")
    .format("YYYYMMDDHHmmss");
  const spId = data.spid;
  const spPwd = data.service_password;
  const productId = data.productid;

  const spPswCombine = spId + spPwd + timeStamp;
  // const spPassword = SHA256(spId + spPwd + timeStamp);
  const spPassword = generateSHA256Hash(spId + spPwd + timeStamp);
  const userId = msisdn;
  console.log("=========SPPswConbine===========");
  console.log(spPswCombine);
  console.log("=========timestamp===========");
  console.log(timeStamp);
  console.log("=========SPID===========");
  console.log(spId);
  console.log("=========SHA256 encrypted===========\n");
  console.log(spPassword);
  console.log("=========SPpwd===========\n");
  console.log(spPwd);
  console.log("=========Product ID===========");
  console.log(productId);
  console.log("=========Mission ID===========");
  console.log(userId);

  const bodyXml = `<?xml version="1.0" encoding="UTF-8"?>
  <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:loc="http://www.csapi.org/schema/parlayx/subscribe/manage/v1_0/local">
     <soapenv:Header>
        <v2:RequestSOAPHeader xmlns:v2="http://WWW.huawei.com.cn/schema/common/v2 1">
           <v2:spId>${spId}</v2:spId>
           <v2:spPassword>${spPassword}</v2:spPassword>
           <v2:timeStamp>${timeStamp}</v2:timeStamp>
           <!--<v2:OA>${userId}</v2:OA>
           <v2:FA>${userId}</v2:FA>
           <v2:oauth_token>72c622720ea94965b536</v2:oauth_token>
           <v2:clientID>002306000001220</v2:clientID>-->
        </v2:RequestSOAPHeader>
     </soapenv:Header>
     <soapenv:Body>
        <loc:subscribeProductRequest>
           <loc:subscribeProductReq>
              <userID>
                 <ID>${userId}</ID>
                 <type>0</type>
              </userID>
              <subInfo>
                 <productID>${productId}</productID>
                 <!--Optional:-->
                 <operCode>zh</operCode>
                 <!--Optional:-->
                 <isAutoExtend>0</isAutoExtend>
                 <channelID>4</channelID>
                 <!--Optional:-->
                 <extensionInfo>
                    <!--Zero or more repetitions:-->
                    <namedParameters>
                       <key>SubType</key>
                       <value>0</value>
                    </namedParameters>
                 </extensionInfo>
              </subInfo>
           </loc:subscribeProductReq>
        </loc:subscribeProductRequest>
     </soapenv:Body>
  </soapenv:Envelope>`;

  console.log(`Body Request ${bodyXml}`);

  const soapHeaders = {
    "user-agent": "terragon",
    "Content-Type": "text/xml;charset=UTF-8",
    soapAction: "",
  };

  const response = await soapRequest({
    url: vLocation,
    headers: soapHeaders,
    xml: bodyXml,
    timeout: 20000,
  }).catch((err) => {
    return callback(err, false);
    throw new Error(err);
  });
  console.log("response from glo" + response);
  let des = "Description not available";
  if (response.subscribeProductRsp.resultDescription) {
    des = response.subscribeProductRsp.resultDescription;
  }

  // return callback(null, response);
  return callback(null, {
    ResultCode: 0,
    ResultDesc: response.subscribeProductRsp.result,
    ResultDetails: des,
  });
}

function unsubscribe(msisdn, data, debug = false, callback) {
  msisdn = msisdnSanitizer(msisdn, false);

  const timeStamp = moment(new Date())
    .utc()
    .add(2, "minutes")
    .format("YYYYMMDDHHmmss");
  const spId = data.spid;
  const spPwd = data.service_password;
  const productId = data.productid;

  //spPassword = md5(spId + spPwd + timeStamp);
  const spPassword = generateSHA256Hash(spId + spPwd + timeStamp);

  // define wsdl options
  const options = {
    endpoint: vLocation,
    returnFault: true,
    wsdl_options: {
      location: vLocation,
      uri,
      trace: 1,
      exceptions: 1,
    },
  };

  const namespace = ns;

  soap.createClient(ws, options, (err, client) => {
    // add header params
    client.addSoapHeader(`
      <tns:RequestSOAPHeader xmlns:tns="${namespace}">
      <tns:spId>${spId}</tns:spId>
      <tns:spPassword>${spPassword}</tns:spPassword>
      <tns:timeStamp>${timeStamp}</tns:timeStamp>
  </tns:RequestSOAPHeader>`);

    // unsubscribe request payload
    const payload = {
      unSubscribeProductReq: {
        userID: {
          ID: msisdn,
          type: "0",
        },
        subInfo: {
          productID: productId,
          channelID: "4",
          isAutoExtend: 0,
        },
        extensionInfo: {
          namedParameters: {
            key: "SubType",
            value: 0,
          },
        },
      },
    };

    // call method
    client.unSubscribeProduct(payload, (err1, result) => {
      if (err) {
        return callback(
          {
            ResultCode: 1,
            ResultDesc: err1,
            ResultDetails: "Subscription Failed",
          },
          null
        );
      }

      let des = "Description not available";

      if (result.unSubscribeProductRsp.resultDescription) {
        des = result.unSubscribeProductRsp.resultDescription;
      }

      if (debug) {
        const xmlRequest = client.getLastRequest();

        console.log("=========Request===========");
        console.log(xmlRequest);
        console.log("=========Request===========\n");
        const xmlResponse = client.getLastResponse();
        console.log("=========Response===========\n");
        console.log(xmlResponse);
        console.log("=========Response===========");

        return false;
      }

      return callback(null, {
        ResultCode: 0,
        ResultDesc: result.unSubscribeProductRsp.result,
        ResultDetails: des,
      });
    });
  });
}

module.exports = {
  subscribe,
  unsubscribe,
  sendSms,
  stopSmsNotification,
  startSmsNotification,
  authorizationLookup,
  serviceCharge,
  genericAuthorization,
  startUssdNotification,
  stopUssdNotification,
  sendUssd,
  otpAuthorization,
};
